#include <stdio.h>
#include <string.h>
#include "utils.h"


void main () {

	char plaintext[4096];
	char plaintext_recovered[4096];
	char chipertext[4096];
	char tag[4096];
	unsigned char key[128];
	unsigned char iv[64];
	int chiperlen;

	printf ("Insert Plaintext: ");
	scanf("%s", plaintext);
	printf("\n");

	if (!RAND_bytes(key, sizeof(key))) {

		printf ("Unable to generate Key!\n");
		exit(-1);
	}

	if (!RAND_bytes(iv, sizeof(iv))) {

		printf ("Unable to generate IV!\n");
		exit(-1);
	}

	printf ("Key is: %s\n\n", base64(key, sizeof(key)));
	printf ("IV is: %s\n\n", base64(iv, sizeof(iv)));

	printf ("Chipertext len is: %d\n\n",chiperlen= gcm_encrypt(plaintext, strlen(plaintext), key, iv, sizeof(iv), chipertext, tag));

	printf("Chiphertext is: %s\n\n", base64(chipertext, chiperlen));
	printf("Tag is: %s\n\n", base64(tag, 16));

	gcm_decrypt(chipertext, chiperlen, tag, key, iv, sizeof(iv), plaintext_recovered);

	printf ("Recovered Plaintext is: %s\n", plaintext_recovered);

}

